/*
 * file name: eAidAna.c
 *
 */

#include	<stdio.h>
#include	<string.h>
#include	<helios/envdef.h>
#include	"eAidAna.h"


/*
 * eAidAnaGetAidOfCommonEnv()
 */
int
eAidAnaGetAidOfCommonEnv(char *myAid, char *fromAid, char **Ans)
{
  unsigned	n, alloc_len;

  if ( eAidAnaIsUser(fromAid) == TRUE ||
       eAidAnaIsUser(myAid) == TRUE ) {
    *Ans = (char*)malloc( 4 );
    if ( *Ans == NULL ) return (ERROR);
    strcpy(*Ans, "---");
    return (NORMAL);
  }
/*** 10/4
  if ( !strcmp(fromAid, "0") || !strcmp(myAid, "0") ) {
    n = 1;
    alloc_len = 2;
  }
***/
  else if ( !strcmp(myAid, fromAid) ) {
    n = strlen(myAid);
    alloc_len = n + 1;
  }
  else {
    for ( n = 1; !strncmp(myAid, fromAid, n); n++ ) {}
    for ( n -= 2; fromAid[n] != AID_SEP; n-- ) {}
    alloc_len = n + 1;
  }

  *Ans = (char*)calloc(alloc_len, 1);
  if ( *Ans == NULL ) return (ERROR);

  strncpy(*Ans, myAid, n);
  return (NORMAL);
}


/*
 * eAidAnaGetSameLevelAid()
 */
int
eAidAnaGetSameLevelAid(char *myAid, char *fromAid, char **Ans)
{
  char	str[256];
  char	*common_env;
  int	i, j, n;
  int	status;
  
  status = eAidAnaGetAidOfCommonEnv(myAid, fromAid, &common_env);
  if ( status != NORMAL ) return (status);

  n = strlen(common_env);

  strcpy(str, common_env);
  str[n] = AID_SEP;
  for ( j = n+1, i = n+1; fromAid[i] != AID_SEP; i++ ) {
    str[j++] = fromAid[i];
  }
  str[j] = NULL;

  *Ans = (char*)malloc( j );
  if ( *Ans == NULL ) return (EALLOC);

  strcpy(*Ans, str);
  return (NORMAL);
}


/*
 * eAidAnaIsUser()
 */
int
eAidAnaIsUser(char *aid)
{
  char	*p;

  p = strchr(aid, AID_SEP);
  if ( p == NULL ) return (TRUE);
  else return (FALSE);
}


/*** END OF FILE ***/
