/* ----------------------------------------------------
                  H E L I O S  ver1.0

$B!!!!!!!!!!!!(B     <<< $BBg0hDj?t%W!<%k(B >>>

		 By H.Kijima [IMS]  1994/7

		    FILE : gl_const.c

       - - - - - - - - - - - - - - - - - - - - - - - -

	       Public Functions and Subroutines

	 (1) void add_to_global_pool();
            $B4D6-$NBg0h%a%b%j$KBg0hDj?t$r%;%C%H$9$k!#(B

	 (2) char *get_value();
            $BBg0h%a%b%j$+$iBg0hDj?t$r;2>H$9$k!#(B

    ----------------------------------------------------        
*/

#include <stdio.h>
#include <helios/HeAgSvDef.h>
#include <helios/HeAgSv.h>


/* Prototype Difinition */
void add_to_global_pool();
char *get_value();
void dump_global_pool();
void dump_global_pool2();

extern char *H_malloc_str();
extern int H_ch_exist_env();

/* extern void debug_dprint(); */

extern H_AGS *H_Envs[];             /* $B4D6-(BObj$B$rJ]4I$9$kG[Ns(B */
extern char  *H_EnvNames[];         /* $B4D6-L>$rJ]4I$9$kG[Ns(B */
extern int H_EnvC;                  /* $B4D6-?t(B */
extern int AgsInitSt;               /* $B%(!<%8%'%s%H%5!<%P=i4|2=7k2L(B */


void add_to_global_pool(Env, Type, Name, Value)
     char *Type;
     char *Env;
     char *Name;
     char *Value;
{
  int state;
  int index;
  char  *s;
  H_AGS *e;
  H_PL  *p, *q;
  
  /* $B%G%#%l%/%H%j=i4|2==hM}Cf$K%(%i!<$,5/$-$F$$$l$P(B */
  if ( AgsInitSt != H_SUC ) return;

  /* $B4{$K4D6-L>$,EPO?$5$l$F$$$l$P(BIndex$B$r<hF@(B */
  state = H_ch_exist_env(Env,&index);
  if (state == H_TRUE) {
    q = H_Envs[index] -> global_pool;

  /* $BL$EPO?$G$"$l$P(B */
  } else {
    if ( NULL !=  (s = H_malloc_str(Env))) {

      /* $B4D6-L>$rEPO?(B */
      strcpy(s, Env);
      H_EnvNames[H_EnvC] = s;
      if ( NULL != (e = (H_AGS *) malloc( sizeof(H_AGS)))) {

	/* $B$=$N4D6-L>$KBP1~$9$k9=B$BN$rMQ0U(B */
	e->method_dir = NULL;
	e->func_dir = NULL;
        e->agent_dir = NULL;
        e->ags_pont = NULL;
        e->p_dir = NULL;

	H_Envs[H_EnvC] = e;
	H_EnvC++;
      } else {
	AgsInitSt = H_MEMERR;
	return;
      }
    } else {
      AgsInitSt = H_MEMERR;
      return;
    }
  }

  /* $BEPO?(B */
  if ( NULL != (p = (H_PL *) (malloc( sizeof( H_PL ) )))) {
    if ( NULL !=  (s = H_malloc_str(Type))) {
      strcpy(s, Type),
      p->type = s;
      if ( NULL !=  (s = H_malloc_str(Name))) {
        strcpy(s, Name);
        p->name = s;
        if ( NULL !=  (s = H_malloc_str(Value))) {
	  strcpy(s, Value);
	  p->value = s;
	  if (state != H_TRUE) {
	    p -> next = NULL;
	    e->global_pool = p;
	  } else {
	    p -> next = q;
	    H_Envs[index]->global_pool = p;
	  }
	  AgsInitSt = H_SUC;
        }
      }
    }
  }
}  


/* get the global constant from the environment pool. */
char *get_value(Env,Name,Type)
     char *Env, *Name, **Type;
{
  int index;
  H_PL *p;
  char *s, *t;

  /* get the environment index */
  if (H_ch_exist_env(Env,&index) == H_FAIL) return( NULL );
  
  p = H_Envs[index]->global_pool;
  
  while( p != NULL ) {
    if ( strcmp(p->name, Name) == H_EQ ) {
      if ( (s = H_malloc_str(p->value)) == NULL ) return(NULL);
      strcpy(s,p->value);
      if ( (t = H_malloc_str(p->type)) == NULL ) return(NULL);
      strcpy(t,p->type);
      *Type = t;
      return(s);
    }
    p = p->next;
  }

  return( NULL );
}


/* dump of global pool content each environment */
void dump_global_pool()
{
  int i;

  H_ags_dprint("DUMP GLOBAL POOL%s\n","");

  for(i=0 ; i < H_EnvC ; i++) {
    dump_global_pool2(i);
  }
  H_ags_dprint("%s\n","");
}

void dump_global_pool2(i)
int i;
{
  H_PL *p;

  p = H_Envs[i]->global_pool;

  H_ags_dprint("Enviroment << %s >>\n",H_EnvNames[i]);

  while( p != NULL ) {
    H_ags_dprint("  TYPE:  %s   ", p->type);
    H_ags_dprint("  Name:  %s   ", p->name);
    H_ags_dprint("  Value: %s \n", p->value);
    p = p->next;
  }
}



